# xboard-xiangqi

#### 一、介绍

 * 用 Xboard 玩中国象棋。命令: xboard-xiangqi
 * version 4.9.1-7, 2020-4-20 updated, by Careone;
 * 
 说明: 象眼 (EleEye) 引擎 3.15 (Linux 版本), 在 Xboard 上运行不稳定，中途可能报错、停止走棋。
     另外，使用 UCCI 协议的中国象棋引擎，需要使用额外选项 uci2wb, -fUCCI, -sUCCI,  
     以及 -uxiAdapter {uci2wb -%variant "%fcp" "%fd"}
     
    用法示例:
 *      说明1: 以下4组命令，都需要在同一行输入!
 *       说明2: "-variant xiangqi" 代表玩中国象棋 (xiangqi), 而不是
              国际象棋 (chess);
 *       说明3: "uci2wb -x" 代表使用 UCCI 中国象棋协议;
 *       说明4: @xq 或者 @xiangqi, 代表加载特定目录下的中国象棋主题
              配置文件, 如 /usr/share/games/xboard/themes/conf/xq ;

 *       用法1:
        xboard -variant xiangqi -fcp "uci2wb -x eleeye_engine" -scp "uci2wb -x eleeye_engine"
 *       用法2:
        xboard @xiangqi -fcp "uci2wb -x eleeye_engine" -scp "uci2wb -x eleeye_engine"
 *       用法3:
        xboard @xiangqi -fcp {uci2wb -x eleeye_engine} -scp {uci2wb -x eleeye_engine}
 *       用法4:
        xboard @xiangqi -uxiAdapter {uci2wb -%variant "%fcp" "%fd"} -fcp eleeye_engine -fUCCI -scp eleeye_engine -sUCCI

  
#### 二、软件架构
all

#### 三、安装教程

 1.  安装依赖的软件包: sudo apt-get install xboard fairymax 
 2.  安装推荐的软件包: sudo apt-get install hoichess sjaakii eleeye
 3.  推荐安装第三方主题包 (DEB): xboard-xiangqi-themes 。下载地址: 
 *   https://sourceforge.net/projects/emacslocale/files/xiangqi/xboard-xiangqi/

#### 四、Xboard 下的中国象棋引擎

 1. maxqi: 象棋水平一般（大致相当于腾迅天天象棋的“业3-业4”水平）。
 软件包 fairymax 自带。通常默认已安装;

 2. hoixiangqi: 象棋水平一般（大致相当于腾迅天天象棋的“业3-业5”水平）。
 需要安装软件包 hoichess;

 3. sjaakii: 象棋水平较高（大致相当于腾迅天天象棋的“业5-业6”水平）。
 需要安装软件包 sjaakii, 并使用 -variant xiangqi 选项，指定棋种为中国象棋。

 * 腾迅天天象棋-残局闯关全部360关: 其中 81.3% 以上 (293/360) 的棋局, 可以使用
 sjaakii 中国象棋引擎自动解出;

 * 《适情雅趣》残局谱 (2009年李浭版) 全部551局的前100局, 81%  (81/100) 可以使用
 sjaakii 中国象棋引擎自动解出；第101-551局的 86.9% (392/451)，可以使用 
 Winboard 4.5.0 自带的象眼 (EleEye) 引擎自动解出。其余棋局, 可以用其它象棋软件引擎
 解出，或者手动编辑走法。
          
#### 五、使用说明

 1.  xboard-xiangqi       直接启动中国象棋
 2.  xboard-xiangqi -s 49     指定棋格大小为 49x49。默认为49, 推荐为47-65
 3.  xboard-xiangqi -t wood   使用木质的棋子/棋盘主题
 4.  xboard-xiangqi --nologo  不显示象棋引擎的 LOGO 图片。这样程序界面会小一些

 5.  xboard-xiangqi -sj -lf [数字1-551] 
  加载棋例《适情雅趣》残局谱第 1-551 局的任意一个 FEN 局面（相当于挑战残局）
  -sj 代表使用棋力较强的中国象棋引擎 sjaakii

 6.  xboard-xiangqi -lg [PGN文件] [数字序号]
    打开 PGN 对局/棋谱文件中的指定棋局。如果未指定文件和数字，则打开棋例

 7.  xboard-xiangqi -h        查看帮助信息和更多功能

#### 六、相关软件包和技术说明

 * Linux下用XBoard玩中国象棋
	2020-2-23, by Careone

适用系统： Debian/ Ubuntu/ Deepin/ UOS

步骤一: 安装 xboard 和 hoichess 软件包

	sudo apt-get install xboard hoichess
	说明：软件包 hoichess 中，包含一个 XBoard 中国象棋引擎 hoixiangqi

步骤二: 下载并安装软件包 xboard-xiangqi
	另外，还可以安装附加的棋子棋盘图片主题包 xboard-xiangqi-themes

	下载地址：
	DEB 安装包: 
	https://sourceforge.net/projects/emacslocale/files/xiangqi/xboard-xiangqi/
	源码: https://gitee.com/atzlinux/xboard-xiangqi

步骤三：直接运行 xboard-xiangqi 即可启动 XBoard 中国象棋。
	另外，还可以使用 -s 选项来指定棋子大小。如：
	xboard-xiangqi -s 60

	指定棋格大小为 60x60。 默认为 49。推荐为 47-65。
	说明: 如果小于 47，则程序上部的菜单栏可能消失。

	其它常用功能：可以使用 -t 选项使用其它象棋主题。如：

	* 2. 木纹主题
	xboard-xiangqi -t wood

	* 3. CCBridge 象棋桥主题
	xboard-xiangqi -t ccbridge

	* 4. 东萍象棋主题
	xboard-xiangqi -t dpxq

#### 七、自定义棋盘、棋子的技术说明

 1.  自定义 [棋盘图片] 的技术说明：中国象棋棋盘图片文件后面，需要加上 -9x10 字样，如
    xqboard-wood-9x10.png,
    这样在缩放棋盘时，九宫斜线中间才不会出现断线或者错位;
 2.  自定义 [棋子图片] 的技术说明：只支持 PNG 或者 SVG 这两种图片格式;

#### 八、挑战中国象棋古谱残局和其它棋局

 1.  挑战《适情雅趣》残局谱551例（2009年李浭版）:
    xboard-xiangqi -sqyq -lg
    也可以直接指定第几局（如第467局，马杀单士）:
    xboard-xiangqi -sqyq -lg 467
    
 2.  挑战腾迅天天象棋----残局闯关550例:
    xboard-xiangqi -ttxq -lg
    
 * 说明1: 从 xboard-xiangqi 4.9.1-6 开始, 支持上面两种残局棋例
 * 说明2: 从 xboard-xiangqi 4.9.1-7 开始, 新增功能选项 -sp, --sample, 同时收录了
 更多的经典古谱残局棋例的 FEN 局面文件。用法示例: 
 
 3. 显示中国象棋棋例列表
    xboard-xiangqi -sp
    
    输出示例如下（可以在 -sp 选项后面加上数字编号，来指定棋例文件）:
    ----------------------------------
 查看可用的 Xboard 中国象棋 PGN/FEN/EPD/POS 棋例文件...
 *   棋例目录: /usr/share/games/xboard/samples/xiangqi/
 *    1	xq_A.EPD_基本杀法_041.fen
 *    2	xq_B.EPD_基本战术_048.fen
 *    3	xq_C.EPD_中局杀法_153.fen
 *    4	xq_D.EPD_象棋杀着大全_575.fen
 *    5	xq_E.EPD_残局攻杀谱_114.fen
 *    6	xq_engine-debug.fen
 *    7	xq_F.EPD_象棋实用残局_第一集_300.fen
 *    8	xq_FUNNY.EPD_趣味象棋_240.fen
 *    9	xq_G.EPD_象棋实用残局_第二集_300.fen
 *    10	xq_H.EPD_橘中秘_残局篇_137.fen
 *    11	xq_I.EPD_适情雅趣_550.fen
 *    12	xq_J.EPD_烂柯神机_249.fen
 *    13	xq_K.EPD_象局汇存_100.fen
 *    14	xq_L.EPD_江湖百局秘谱_100.fen
 *    15	xq_sqyq_2009-551f.fen
 *    16	xxq-shiQingYaQu_2009-551f.fen
 *    17	xxq-shiQingYaQu_2009-551p.pgn
 *    18	xxq-tianTianXQ-cg360f.fen
 *    19	xxq-tianTianXQ-cg360p.pgn
 *   ----------------------------------

 4. 加载指定的第几个（如第6个）棋例文件
    xboard-xiangqi -sp 8 -lf
    说明：第6个棋例文件 xq_engine-debug.fen ，收录了《适情雅趣》551局，以及
        腾迅天天象棋----残局闯关360局，不能用 sjaakii 中国象棋引擎正常解出的
        棋例（共145例）。可用于重点测试、修正其它中国象棋引擎的可靠性；
        或用于新的中国象棋引擎的测试用例。

#### 九、Xboard 常见问题

 1.  如果同时打开了多个 xboard 程序，这时如果用 pkill xboard 命令批量杀死 Xboard 
 程序，则下次运行 xboard 或者 xboard-xiangqi 时，可能会报错：无法读取XX文件，或者无
 法识别的选项。

 * 原因: 在用 pkill 命令批量杀死多个 xboard 程序时，可能会在配置文件的最后面，写入
     错误的数据。如: xboard 中国象棋的个人配置文件 ~/.xboard-xiangqi-rc , 或者 
     xboard 的配置文件 ~/.xboardrc   
 * 解决: 删除个人配置文件最后面的错误数据；或者直接删除整个配置文件。

#### 十、WinBoard 中国象棋

 * Xboard 移植到 Windows 操作系统后，叫做 WinBoard。

 1. WinBoard 热门网站和论坛 (英文版): 
 * http://hgm.nubati.net/
 * https://blog.hartwork.org/?p=2515
 * http://www.open-aurec.com/wbforum/

 2. Windows 操作系统下的中国象棋软件和引擎:
  象棋百科全书网(中文): http://www.xqbase.com/resource.htm#downloads

 3. WinBoard 中国象棋专用版介绍 (英文版): 
  http://home.hccnet.nl/h.g.muller/XQwinboard.html

 * Winboard 4.5.0 中国象棋专用版
    在网上搜索 winboard-XQ.exe 即可。参考下载地址:
    http://hgm.nubati.net/WinBoard-XQ.exe
    	文件大小: 1.3 MB
  
   对应的版本是早期的 WinBoard 4.5.0 版本 (程序界面为英文，不包含中文菜单翻译文件)。
   这个版本自带中国象棋引擎“象眼 (EleEye) 3.1”, 棋力水平大约相当于腾迅天天象棋
  “业5-业7”的水平。另外还自带了其它几种中国象棋引擎（包括“浅红”引擎）。
 
 * Winboard 最新版为 4.8.0 (截止2020年3月)
    在网上搜索, 或者在Windows电脑软件下载站点查找 WinBoard Portable 即可。
    参考下载地址: 
    ** http://hgm.nubati.net/
    ** https://portableapps.com/apps/games/winboard_portable

	 文件大小: 3 MB
	 程序发布日期: 2016-05-20
	 操作系统平台: Windows XP/Vista/7/8/10
 
     这一版本自带有简体和繁体中文翻译文件，但默认菜单界面为英文。默认打开国际象棋 
 (chess)，而不是中国象棋 (Xiangqi)。同样自带有中国象棋引擎“象眼 (EleEye) 3.1”和
 其它几种中国象棋引擎（包括“浅红”引擎）。
        
#### 十一、码云特技

1.  使用 Readme\_XXX.md 来支持不同的语言，例如 Readme\_en.md, Readme\_zh.md
